from flask import Flask, request, Blueprint, jsonify, json, redirect, url_for,flash, render_template,session, app,Response
#import collections
import urllib.request
import datetime
import math
import string
import boto3, botocore
import io
import os
import csv
import logging
import base64

from random import randint
from datetime import timedelta,date,datetime
import dateutil.relativedelta
from dateutil.relativedelta import relativedelta
from werkzeug.utils import secure_filename
from os.path import join, dirname, realpath
from botocore.exceptions import ClientError
from urllib.parse import unquote
from io import StringIO
from PIL import Image
from collections import defaultdict
#Numerotec libraries
from .. import Cryptography,Auth,RouteGroup,Helper,CSVEXPORT
from core.library.email import EMAIL
#Models
from core.model.UserModel import UserModel

app = Blueprint('bo', __name__)

# autologin from membership backoffice
@app.route('/<society_id>/<society_key>/at_mem/<uuid>', methods = ["GET", "POST"])
@RouteGroup.society_required
def autoLoginFromMembership(society_id,society_key,uuid):
	societyData    = Auth.getSociety(society_id)
# 	timestamp      = round(int(timestamp[:-3]))
# 	timestamp      = datetime.fromtimestamp(int(timestamp))
	if societyData:
		userData  = UserModel().get_user_data_by_uuid(uuid)
		if userData:
			bo_access = UserModel().check_bo_access(userData['email'],4,society_id,None)
			if  bo_access and bo_access["is_admin"] == 1 :
				userData["is_admin"] =  bo_access["is_admin"]
				Auth.bo_login(userData['full_name'],society_id)
				return redirect(url_for('bo.Home_Index',society_id=society_id,society_key=society_key))
			else:
				flash("Email id is not registered." )
				return redirect (url_for('bo.Login',society_id=society_id,society_key=society_key)) 
		else:
			flash("Email id is not registered." )
			return redirect (url_for('bo.Login',society_id=society_id,society_key=society_key)) 
	else:
		return redirect (url_for('bo.Login',society_id=society_id,society_key=society_key))

# autologin for profile backoffice
@app.route('/<society_id>/<society_key>/admin/at/<uuid>/<timestamp>', methods = ["GET", "POST"])
@RouteGroup.society_required
def autoLoginForBackoffice(society_id,society_key,uuid,timestamp):
	societyData    = Auth.getSociety(society_id)
	timestamp      = round(int(timestamp[:-3]))
	timestamp      = datetime.fromtimestamp(int(timestamp))
	if timestamp and (datetime.now() < timestamp):
		user_data  = UserModel().get_user_data_by_uuid(uuid)
		if user_data:
			Auth.bo_login(user_data,society_id)
			return redirect(url_for('bo.Home_Index',society_id=society_id,society_key=society_key))
		else:
			return redirect(url_for('bo.Login',society_id=society_id,society_key=society_key))
	else:
		return redirect(url_for('bo.Login',society_id=society_id,society_key=society_key))

@app.route('/<society_id>/<society_key>/admin', methods = ["GET", "POST"])
@RouteGroup.society_required
def Home(society_id,society_key):
	if Auth.bo_check(society_id):
		return redirect(url_for('bo.Home_Index',society_id=society_id,society_key=society_key))
	else:
		return redirect(url_for('bo.Login',society_id=society_id,society_key=society_key))

@app.route('/<society_id>/<society_key>/bo/login')
@RouteGroup.society_required
def Login(society_id,society_key):
	societyData     = Auth.getSociety(society_id)
	return render_template('bo/login_screen.html',society_id=society_id,society_key=society_key,societyData=societyData)

@app.route('/<society_id>/<society_key>/bo/pos_login',methods = ["GET","POST"])
@RouteGroup.society_required
def Bo_Post_login(society_id,society_key):
	if request.method == "POST":
		user_name     = request.form['user_name']
		# password      = request.form["password"]
		is_admin_access 	= UserModel().check_bo_access(user_name,4,society_id,None)
		is_admin 	= is_admin_access['is_admin']
		if  user_name and int(is_admin) == 1 :
			Auth.bo_login(user_name,society_id)
			return redirect(url_for('bo.Home_Index',society_id=society_id,society_key=society_key)) 
			# flash('Please enter your user name ')
			# return redirect (url_for('bo.Login',society_id=society_id,society_key=society_key))
		# else :
			# admin_name     = 'admin'
			# admin_password = 'admin@123'
			# if user_name == admin_name and password == admin_password:
				# Auth.bo_login(admin_name,society_id)
				# return redirect(url_for('bo.Home_Index',society_id=society_id,society_key=society_key)) 
		else:
			flash("Email id is not registered." )
			return redirect (url_for('bo.Login',society_id=society_id,society_key=society_key)) 
	return render_template('bo/login_screen.html',society_id=society_id,society_key=society_key)

@app.route('/<society_id>/<society_key>/bo/logout', methods = ["GET", "POST"])
@RouteGroup.society_required
def Bo_Logout(society_id,society_key):
	Auth.bo_logout(society_id)  
	return redirect(url_for('bo.Login',society_id=society_id,society_key=society_key))

@app.route('/<society_id>/<society_key>/bo/search',methods = ["GET","POST"])
@RouteGroup.society_required
@RouteGroup.bo_login_required
def Search(society_id,society_key):
	societyData = Auth.getSociety(society_id)
	return render_template('bo/bo_search.html',society_id=society_id,society_key=society_key,societyData=societyData)

@app.route('/<society_id>/<society_key>/bo/search_post',methods = ["GET","POST"])
@RouteGroup.society_required
@RouteGroup.bo_login_required
def Search_post(society_id,society_key):
	if request.method == "POST":
		search_text = request.form.get("search_text")
		order_by    = request.form.get("order_by")
		fromdate    = request.values.get("fromdate")
		todate      = request.values.get("todate")
		# print("Type of to date",type(todate))
		return redirect(url_for('bo.Search_Index',order_by=order_by,search_text=search_text,society_id=society_id,society_key=society_key,fromdate=fromdate,todate=todate))
	else:
		return render_template('bo/bo_search.html',society_id=society_id,society_key=society_key)

@app.route('/<society_id>/<society_key>/<in_filter>/bo/search_index',methods = ["GET","POST"])
@app.route('/<society_id>/<society_key>/bo/search_index',methods = ["GET","POST"])
@RouteGroup.society_required
@RouteGroup.bo_login_required
def Search_Index(society_id,society_key,in_filter=None):
	societyData     = Auth.getSociety(society_id)
	search_text     = request.values.get('search_text',None) or None
	in_order        = 1
	# order_by    = request.values["order_by"]
	attach_type_id  = societyData['attach_type_id']
	# attach_type_id = Helper.attch_type_id[society_key]
	district        = None
	in_filter       = None
	limit           = int(request.values.get('limit',20))
	offset          = 0
	fromdate        = request.values.get('fromdate',None)or None
	todate          = request.values.get('todate',None)or None
	in_profile_filter = None
	member_type_id = None
	search_data     = UserModel().usp_data_for_district_wise_v1(society_id,search_text,attach_type_id,district,in_filter,in_profile_filter,member_type_id,fromdate,todate,in_order,offset,limit)
	# search_data = UserModel().search_data(search_text,society_id,attach_type_id)
	for index,value in enumerate(search_data) :
		if index == 0 :
			data        = value  
		if index == 1 :
			total_count = value[0]
	total_count     = int(total_count['total_member'])
	page            = int(request.values.get('page',1))
	num_of_page     = total_count/limit
	no_of_page      = math.ceil(num_of_page)
	no_of_page      = int(no_of_page)
	offset          = (page-1)*limit
	return render_template('bo/common_index.html',datas=data,society_id=society_id,society_key=society_key,societyData=societyData,in_filter=in_filter,page=page,total_count=total_count,no_of_page=no_of_page,limit=limit,offset=offset,search_text=search_text)


@app.route('/<user_id>/<society_id>/<society_key>/bo/get_user',methods=["GET","POST"])
@RouteGroup.society_required
def Get_User(user_id,society_id,society_key):
	societyData = Auth.getSociety(society_id)
	# user_id = request.values.get("user_id")
	user_id         = unquote(user_id)
	user_id         = int(Cryptography.decrypt(user_id))
	attach_type_id  = societyData['attach_type_id']
	# attach_type_id = Helper.attch_type_id[society_key]
	user_data = UserModel().get_member_attachment(user_id,attach_type_id)
	if (int(society_id))==10:
		specialities      = UserModel().get_specialities(user_id)
	else:
		specialities = None
	# member_type_id = Auth.user(society_id).get('member_type_id')
	# user_data = UserModel().get_user_data(user_id,society_id,attach_type_id)
	if user_data:
		if int(society_id)==10:
			attach_type_id = 67
			upload_details = UserModel().get_upload_details(society_id,attach_type_id)
			img = UserModel().get_fellowship_data(user_id,attach_type_id)
			govt_proof = render_template('users/govt_proof.html',upload_details=upload_details,img=img,societyData=societyData)
			return render_template('bo/kos_user_view_model.html',data = user_data,society_id=society_id,society_key=society_key,societyData=societyData,specialities=specialities,govt_proof=govt_proof)
		elif int(society_id) == 36:
			attach_type_id = '75,76,79'
			upload_details = UserModel().get_upload_details(society_id,attach_type_id)
			img = UserModel().get_fellowship_data(user_id,attach_type_id)
			fellowship_data = render_template('users/yosi_certificates.html',upload_details=upload_details,img=img,societyData=societyData,society_id=society_id)
			return render_template('bo/yosi_user_view_model.html',data = user_data,society_id=society_id,society_key=society_key,societyData=societyData,specialities=specialities,fellowship_data=fellowship_data)
		else:	
			return render_template('bo/user_view_model.html',data = user_data,society_id=society_id,society_key=society_key,societyData=societyData)
	else:	
		if int(society_id)==10:
			attach_type_id = 67
			upload_details = UserModel().get_upload_details(society_id,attach_type_id)
			img = UserModel().get_fellowship_data(user_id,attach_type_id)
			govt_proof = render_template('users/govt_proof.html',upload_details=upload_details,img=img,societyData=societyData)
			return render_template('bo/kos_user_view_model.html',data = user_data,society_id=society_id,society_key=society_key,societyData=societyData,specialities=specialities,govt_proof=govt_proof)
		elif int(society_id) == 36:
			attach_type_id = '75,76,79'
			upload_details = UserModel().get_upload_details(society_id,attach_type_id)
			img = UserModel().get_fellowship_data(user_id,attach_type_id)
			fellowship_data = render_template('users/yosi_certificates.html',upload_details=upload_details,img=img,societyData=societyData,society_id=society_id)
			return render_template('bo/yosi_user_view_model.html',data = user_data,society_id=society_id,society_key=society_key,societyData=societyData,specialities=specialities,fellowship_data=fellowship_data)
		return render_template('bo/user_view_model.html',data = user_data,society_id=society_id,society_key=society_key,societyData=societyData)
	


@app.route('/<society_id>/<society_key>/bo/home_index',methods = ["GET","POST"])
@RouteGroup.society_required
@RouteGroup.bo_login_required
def Home_Index(society_id,society_key):
	if request.method == "POST":
		in_profile_filter = request.values.get('in_profile_filter') or None
	else:		
		in_profile_filter = 0
	societyData     = Auth.getSociety(society_id)
	datas           = UserModel().get_bo_dashboard_count_v1(society_id,in_profile_filter)
	for index,value in enumerate(datas) :
		if index == 0 :
			data    = value
	in_count        = None
	in_filter       = 'dashboard'
	in_from         = None
	in_to           = None

	analytic_data   = UserModel().usp_profile_analytics_v2(society_id,in_count,in_filter,in_from,in_to,in_profile_filter)
	for index,value in enumerate(analytic_data) :
		if index == 0 :
			monthwise_data   = value 
		if index == 1:
			datewise_data    = value

	end_month = datetime.now()
	end_month = datetime.date(end_month)
	start_month = end_month - dateutil.relativedelta.relativedelta(months=2)
	
	month_list=[]
	while start_month <= end_month:
		month_year_format = start_month.strftime("%B,%Y")
		month_list.append(month_year_format)
		start_month += timedelta(days=32 - start_month.day)
		start_month = start_month.replace(day=1)
	
	monthwise_data = list(reversed(monthwise_data))
	months_label      = []
	months_counts     = []
	months_sum_counts = []
	count_month ={}
	for m in monthwise_data:
		# count = m['user_count']
		month = m['month_name']
		months_label.append(month)
		count_month[month]=m['user_count']
	for ml in month_list:
		if ml in(months_label):
			count = count_month[ml]
			months_counts.append(count)
		else:
			months_counts.append(0)
		months_sum_counts.append(sum(months_counts))
	maxValue = max(months_sum_counts)
	minValue = min(months_sum_counts)
	# length   = len(months)

	end_date = datetime.now()
	end_date = datetime.date(end_date)
	start_date = end_date - timedelta(days=6)
	date_list = []
	while start_date <= end_date:
		date_list.append(start_date.strftime('%d-%m-%Y'))
		start_date += timedelta(days=1)
	
	datewise_data = list(reversed(datewise_data))
	dates_label      = []
	dates_counts     = []
	dates_sum_counts = []
	count_data = {}
	for d in datewise_data:
		date  = d['date_no']
		count_data[date.strftime('%d-%m-%Y')] = d['user_count']
		dates_label.append(date.strftime('%d-%m-%Y'))
	for dl in date_list:
		if dl in (dates_label):
			count = count_data[dl] 
			dates_counts.append(count)
		else:
			dates_counts.append(0)
		dates_sum_counts.append(sum(dates_counts))
	date_maxValue = max(dates_sum_counts)
	date_minValue = min(dates_sum_counts)
	
	# date_length   = len(dates)
	if int(society_id)== 10:
		return render_template('bo/bo_kos_home.html',society_id=society_id,society_key=society_key,societyData=societyData,data=data,date_minValue=date_minValue,date_maxValue=date_maxValue,months_label=months_label,months_sum_counts=months_sum_counts,dates_sum_counts=dates_sum_counts,dates_label=dates_label,maxValue=maxValue,minValue=minValue,dates_counts=dates_counts,months_counts=months_counts,in_profile_filter=in_profile_filter,date_list=date_list,month_list=month_list,datetime=datetime)
	else:	
		return render_template('bo/bo_home.html',society_id=society_id,society_key=society_key,societyData=societyData,data=data,date_minValue=date_minValue,date_maxValue=date_maxValue,months_label=months_label,months_sum_counts=months_sum_counts,dates_sum_counts=dates_sum_counts,dates_label=dates_label,maxValue=maxValue,minValue=minValue,dates_counts=dates_counts,months_counts=months_counts,in_profile_filter=in_profile_filter,date_list=date_list,month_list=month_list,datetime=datetime)

# # @app.route('/<society_id>/<society_key>/<in_filter>/bo/post_home_index',methods = ["GET","POST"])
# @app.route('/<society_id>/<society_key>/bo/post_home_index',methods = ["GET","POST"])
# @RouteGroup.society_required
# @RouteGroup.bo_login_required
# def PostHomeIndex(society_id,society_key):
# 	societyData     = Auth.getSociety(society_id)
# 	in_profile_filter = request.values.get('in_profile_filter') or None
# 	datas           = UserModel().get_bo_dashboard_count_v1(society_id,in_profile_filter)
# 	for index,value in enumerate(datas) :
# 		if index == 0 :
# 			data    = value
# 	in_count        = None
# 	in_filter       = 'dashboard'
# 	in_from         = None
# 	in_to           = None

# 	analytic_data   = UserModel().usp_profile_analytics_v2(society_id,in_count,in_filter,in_from,in_to,in_profile_filter)
# 	for index,value in enumerate(analytic_data) :
# 		if index == 0 :
# 			monthwise_data   = value 
# 		if index == 1:
# 			datewise_data    = value

# 	end_month = datetime.now()
# 	end_month = datetime.date(end_month)
# 	start_month = end_month - dateutil.relativedelta.relativedelta(months=2)
	
# 	month_list=[]
# 	while start_month <= end_month:
# 		month_year_format = start_month.strftime("%B,%Y")
# 		month_list.append(month_year_format)
# 		start_month += timedelta(days=32 - start_month.day)
# 		start_month = start_month.replace(day=1)

# 	monthwise_data = list(reversed(monthwise_data))
# 	months_label      = []
# 	months_counts     = []
# 	months_sum_counts = []
# 	count_month ={}
# 	for m in monthwise_data:
# 		# count = m['user_count']
# 		month = m['month_name']
# 		months_label.append(month)
# 		count_month[month]=m['user_count']
# 	for ml in month_list:
# 		if ml in(months_label):
# 			count = count_month[ml]
# 			months_counts.append(count)
# 		else:
# 			months_counts.append(0)
# 		months_sum_counts.append(sum(months_counts))
# 	maxValue = max(months_sum_counts)
# 	minValue = min(months_sum_counts)
	
# 	end_date = datetime.now()
# 	end_date = datetime.date(end_date)
# 	start_date = end_date - timedelta(days=6)
# 	date_list = []
# 	while start_date <= end_date:
# 		date_list.append(start_date.strftime('%d-%m-%Y'))
# 		start_date += timedelta(days=1)
	
# 	datewise_data = list(reversed(datewise_data))
# 	dates_label      = []
# 	dates_counts     = []
# 	dates_sum_counts = []
# 	count_data = {}
# 	for d in datewise_data:
# 		date  = d['date_no']
# 		count_data[date.strftime('%d-%m-%Y')] = d['user_count']
# 		dates_label.append(date.strftime('%d-%m-%Y'))
# 	for dl in date_list:
# 		if dl in (dates_label):
# 			count = count_data[dl] 
# 			dates_counts.append(count)
# 		else:
# 			dates_counts.append(0)
# 		dates_sum_counts.append(sum(dates_counts))
# 	date_maxValue = max(dates_sum_counts)
# 	date_minValue = min(dates_sum_counts)
# 	# date_length   = len(dates)
# 	return render_template('bo/bo_home.html',society_id=society_id,society_key=society_key,societyData=societyData,data=data,date_minValue=date_minValue,date_maxValue=date_maxValue,months_label=months_label,months_sum_counts=months_sum_counts,dates_sum_counts=dates_sum_counts,dates_label=dates_label,maxValue=maxValue,minValue=minValue,dates_counts=dates_counts,months_counts=months_counts,in_profile_filter=in_profile_filter,month_list=month_list,date_list=date_list)


@app.route('/<society_id>/<society_key>/bo/districtlist/<in_profile_filter>',methods=["GET","POST"])
@app.route('/<society_id>/<society_key>/bo/districtlist',methods=["GET","POST"])
@RouteGroup.society_required
def DistrictList(society_id,society_key,in_profile_filter=0):
	in_profile_filter = in_profile_filter
	val= 1
	datas       = UserModel().usp_district_list(society_id,val,in_profile_filter)
	societyData = Auth.getSociety(society_id)
	for index,value in enumerate(datas) :
		if index == 0 :
			data                     = value   
		if index == 1 :
			total_profile_updated    = value [0]
	return render_template('bo/district_list_for_static.html',datas=data,total=total_profile_updated,society_id=society_id,societyData=societyData,society_key=society_key,in_profile_filter=in_profile_filter,datetime=datetime)


@app.route('/<society_id>/<society_key>/<district>/<in_filter>/<in_profile_filter>/bo/membersdistrict',methods=["GET","POST"])
@app.route('/<society_id>/<society_key>/<district>/bo/membersdistrict',methods=["GET","POST"])
@RouteGroup.society_required
def CommonMembersDistrict(society_id,society_key,district,in_filter=None,in_profile_filter=0):
	societyData = Auth.getSociety(society_id)

	search_text = request.values.get('search_text',None) or None
	in_order    =  1
	district    =  unquote(district)
	offset      = 0
	limit       = int(request.values.get('limit') or 20)
	in_filter   = in_filter
	fromdate    = None
	todate      = None
	in_profile_filter = in_profile_filter
	attach_type_id  = societyData['attach_type_id']
	member_type_id=None
	# attach_type_id = Helper.attch_type_id[society_key]
	datas     = UserModel().usp_data_for_district_wise_v1(society_id,search_text,attach_type_id,district,in_filter,in_profile_filter,member_type_id,fromdate,todate,in_order,offset,limit)
	for index,value in enumerate(datas) :
		if index == 0 :
			districtlist   = value 
		if index == 1:
			district_count = value[0] 
	total_count = district_count['total_member']
	total_count = int(total_count)
	page        = int(request.values.get('page') or 1)
	num_of_page = total_count/limit
	no_of_page  = math.ceil(num_of_page)
	no_of_page  = int(no_of_page)
	offset      = (page-1)*limit
	return render_template('bo/common_index.html',datas=districtlist,in_filter=in_filter,district=district,society_id=society_id,society_key=society_key,societyData=societyData,page=page,total_count=total_count,no_of_page=no_of_page,limit=limit,offset=offset)

	# return render_template('bo/district_list_for_members.html',datas=districtlist,district=district,societyData=societyData,society_id=society_id,society_key=society_key,district_count=district_count)   



@app.route('/<society_id>/<society_key>/<in_filter>/bo/common_index',methods = ["GET","POST"])
@app.route('/<society_id>/<society_key>/<in_filter>/<in_profile_filter>/bo/common_index',methods = ["GET","POST"])
@app.route('/<society_id>/<society_key>/bo/common_index',methods = ["GET","POST"])
@RouteGroup.society_required
@RouteGroup.bo_login_required
def CommonIndex(society_id,society_key,in_filter=None,in_profile_filter=0):
	societyData     = Auth.getSociety(society_id)
	status_id       = societyData['ms_approved_status_id']
	# attach_type_id = Helper.attch_type_id[society_key]
	attach_type_id  = societyData['attach_type_id']
	search_text     = request.values.get('search_text',None) or None
	district        = None
	in_filter       = in_filter
	in_profile_filter = in_profile_filter
	offset          = 0
	limit           = int(request.values.get('limit',20))
	in_order        = 1
	fromdate        = None
	todate          = None
	member_type_id = None
	profile_member_types = UserModel().get_profile_member_type_by_society_id(society_id)
	if profile_member_types == None:
		profile_member_types = UserModel().get_profile_member_type()
	# datas = UserModel().usp_get_profile_bo_data(society_id,status_id,attach_type_id,offset,limit)
	datas           = UserModel().usp_data_for_district_wise_v1(society_id,search_text,attach_type_id,district,in_filter,in_profile_filter,member_type_id,fromdate,todate,in_order,offset,limit)
	# return jsonify(datas)
	if datas is None:
		print("There is no data in Incomplete Data",society_id,status_id,attach_type_id)
	else:
		for index,value in enumerate(datas) :
			if index == 0 :
				datas      = value
			if index == 1 :
				data      = value
		total_count =  data[0]['total_member'] if data else 0
		total_count = int(total_count)
		page        = int(request.values.get('page',1))
		limit       = int(request.values.get('limit',20))
		offset      = 0
		num_of_page = total_count/limit
		no_of_page  = math.ceil(num_of_page)
		no_of_page  = int(no_of_page)
		offset      = (page-1)*limit
		status_id   = societyData['ms_approved_status_id']
		# attach_type_id = Helper.attch_type_id[society_key]
		attach_type_id  = societyData['attach_type_id']
		return render_template('bo/common_index.html',data = data,datas=datas,society_id=society_id,society_key=society_key,societyData=societyData,in_filter=in_filter,total_count=total_count,page=page,no_of_page=no_of_page, limit=limit,offset=offset,in_profile_filter=in_profile_filter,profile_member_types=profile_member_types)


@app.route('/post_commonindex_pagination/<society_id>/<society_key>/<string:district>/<int:in_filter>/bo', methods=["POST","GET"])
@app.route('/post_commonindex_pagination/<society_id>/<society_key>/<int:in_filter>/bo', methods=["POST","GET"])
@app.route('/post_commonindex_pagination/<society_id>/<society_key>/<int:in_filter>/<in_profile_filter>/bo', methods=["POST","GET"])
@app.route('/post_commonindex_pagination/<society_id>/<society_key>/<string:district>/bo', methods=["POST","GET"])
@app.route('/post_commonindex_pagination/<society_id>/<society_key>/bo', methods=["POST","GET"])
@RouteGroup.society_required
def PostCommonIndexPagination(society_id,society_key,district=None,in_filter=None,in_profile_filter=0):
	page  = int(request.values.get('page',1))
	# print("page",page)
	limit=int(request.values.get('limit',20))
	# print("limit",limit)
	in_profile_filter=request.values.get('in_profile_filter',0) or 0
	member_type     = request.form.getlist('profile_member_type',None)or None
	if member_type:
		member_type_id  =  ",".join(member_type)
	else:
		member_type_id     = None

	btn   = request.values.get('export_btn')

	profile_member_types = UserModel().get_profile_member_type_by_society_id(society_id)

	if btn=="Export":
		try:
			in_order = int(request.values.get('sorted_by'))
		except:
			in_order = 1
		offset          = 0
		limit           = 500000
		societyData     = Auth.getSociety(society_id)
		search_text     = request.values.get('search_text',None) or None
		# status_id      = societyData['ms_approved_status_id']
		# attach_type_id = Helper.attch_type_id[society_key]
		attach_type_id  = societyData['attach_type_id']
		if district:
			district    = urllib.parse.unquote(district)
		in_filter       = in_filter
		in_profile_filter = in_profile_filter
		fromdate        = request.values.get('fromdate',None) or None
		todate          = request.values.get('todate',None) or None
		# print(society_id,search_text,attach_type_id,district,in_filter,in_profile_filter,fromdate,todate,in_order,offset,limit)
		datas           = UserModel().usp_data_for_district_wise_v1(society_id,search_text,attach_type_id,district,in_filter,in_profile_filter,member_type_id,fromdate,todate,in_order,offset,limit)
		for index,value in enumerate(datas) :
				if index == 0 :
					rows      = value
				if index == 1 :
					data      = value
		total_count     = data[0]['total_member']
		total_count     = int(total_count)
		# societyData     = UserModel().get_society(society_id,society_key)
		now             = datetime.now()
		date            = now.strftime("%Y-%m-%d %H:%M")
		file_name   =   societyData['society_intial']+"_"+"Profile_Update"+"_"+str(date)
		if int(society_id)==3:
			header      = {'membership_no':'Membership No', 'prefix_full_name':'Dr Name','gender':'Gender', 'email': 'Email','mobile':'Mobile','city':'City','district':'District','profile_updated_at':'Profile updated date','gov_proof_type':'Proof Type','gov_proof_id':'Proof Id No'}
		else:
			header      = {'membership_no':'Membership No', 'prefix_full_name':'Dr Name','gender':'Gender', 'email': 'Email','mobile':'Mobile','city':'City','district':'District','profile_updated_at':'Profile updated date'}
		return CSVEXPORT.export_csv_file(rows,file_name,header)
	else:
		try:
			in_order = int(request.values.get('sorted_by'))
		except:
			in_order = 1
		societyData  = Auth.getSociety(society_id)
		# limit=int(request.values.get('limit',20))
		offset          = (page-1)*limit
		search_text     = request.values.get('search_text','') or ''
		fromdate        = request.values.get('fromdate',None) or None
		todate          = request.values.get('todate',None) or None
		status_id       = societyData['ms_approved_status_id']
		# attach_type_id = Helper.attch_type_id[society_key]
		attach_type_id  = societyData['attach_type_id']
		if district:
			district    = urllib.parse.unquote(district)
		in_filter       = in_filter
		in_profile_filter = in_profile_filter
		datas           = UserModel().usp_data_for_district_wise_v1(society_id,search_text,attach_type_id,district,in_filter,in_profile_filter,member_type_id,fromdate,todate,in_order,offset,limit)
		for index,value in enumerate(datas) :
				if index == 0:
					datas     = value
				if index == 1 :
					data      = value
		total_count   = data[0]['total_member']
		total_count   = int(total_count)
		num_of_page   = total_count/limit
		no_of_page    = math.ceil(num_of_page)
		no_of_page    = int(no_of_page)
		return render_template('bo/common_index.html',data = data,datas=datas,district=district,member_type_id=member_type_id,society_id=society_id,society_key=society_key,in_filter=in_filter,societyData=societyData,search_text=search_text,total_count=total_count,page=page,no_of_page=no_of_page,profile_member_types=profile_member_types,fromdate=fromdate,todate=todate,limit=limit,offset=offset)
	return redirect(url_for('bo.CommonIndex',society_id=society_id,society_key=society_key))

@app.route('/<user_id>/<society_id>/<society_key>/bo/edit_user',methods=["GET","POST"])
@RouteGroup.society_required
@RouteGroup.bo_login_required
def Edit_User(user_id,society_id,society_key):
	societyData     = Auth.getSociety(society_id)
	user_id         = unquote(user_id)
	user_id         = int(Cryptography.decrypt(user_id))
	state           = UserModel().get_state()
	country         = UserModel().get_country()
	# attach_type_id = Helper.attch_type_id[society_key]
	attach_type_id  = societyData['attach_type_id']
	user_data = UserModel().get_member_attachment(user_id,attach_type_id)
	# user_data       = UserModel().get_user_data(user_id,society_id,attach_type_id)
	#print("user_data :",user_data)
	if (int(society_id))==10:
		specialities      = UserModel().get_specialities(user_id)
	else:
		specialities = None
	if user_data:
		if int(society_id)==10:
			attach_type_id = 67
			upload_details = UserModel().get_upload_details(society_id,attach_type_id)
			img = UserModel().get_fellowship_data(user_id,attach_type_id)
			govt_proof = render_template('users/govt_proof.html',upload_details=upload_details,img=img,societyData=societyData)
			return render_template('bo/kos_bo_edit.html',data = user_data,society_id=society_id,state=state,country=country,society_key=society_key,societyData=societyData,specialities=specialities,govt_proof=govt_proof)
		elif int(society_id) == 36:
			attach_type_id = '75,76,79'
			upload_details = UserModel().get_upload_details(society_id,attach_type_id)
			img = UserModel().get_fellowship_data(user_id,attach_type_id)
			fellowship_data = render_template('users/yosi_certificates.html',upload_details=upload_details,img=img,societyData=societyData,society_id=society_id)
			return render_template('bo/yosi_bo_edit.html',data = user_data,society_id=society_id,state=state,country=country,society_key=society_key,societyData=societyData,specialities=specialities,fellowship_data=fellowship_data)
		else:
			return render_template('bo/bo_edit.html',data = user_data,society_id=society_id,state=state,country=country,society_key=society_key,societyData=societyData)
	else:
		print("User not found")
		return redirect(url_for('bo.Search_Index',society_id=society_id,society_key=society_key))

@app.route('/get_state',methods=["GET","POST"])
def getState():
	country_id = request.values.get("country_id")
	state_data = UserModel().get_country_data(country_id)
	return jsonify(state_data if state_data else '')

@app.route('/<society_id>/<society_key>/bo/profile',methods=["POST"])
@RouteGroup.society_required
@RouteGroup.bo_login_required
def UpdateProfile(society_id,society_key):
	if request.method == "POST":
		user         = Auth.user(society_id)
		user_id      = request.values.get("user_id",None)
		if int(society_id)==10:
			role_of_faculty = request.form.getlist('role_of_faculty_you_are_interested')
			role_of_faculty_you_are_interested=','.join(role_of_faculty)
		else:
			role_of_faculty_you_are_interested = None
		dob          = request.form.get('dob') or None
		if dob:
			try:
				dob = datetime.strptime(dob, '%d-%m-%Y')
			except Exception as e:
				dob = None
		else:
			dob = None
		data =  {
			'prefix'      : request.form.get("prefix",None),
			'full_name'   : request.form.get("name",None),
			'mobile'      : request.form.get("mobile",None),
			'email'       :  request.form.get('email'),
			'gender'      : request.form.get("gender",None),
			'dob'         : dob,
# 			'dob'         : (request.form.get("year",None)+"-"+request.form.get("month",None)+"-"+request.form.get("date",None)),
			'mc_number'   : request.form.get("mc_number",None),
			'mc_state_id' : request.values.get("mc_state",None) or None,
			'phone_home'  : request.form.get("phone_home",None),
			'phone_office': request.form.get("phone_office",None),
			'address1'    : request.form.get("address1",None),
			'address2'    : request.form.get("address2",None),
			'address3'    : request.form.get("address3",None),
			'state_id'    : request.values.get("state",None) or None,
			'country_id'  : request.values.get("country",None) or None,
			'city'        : request.values.get("city",None),
			'pincode'     : request.form.get("pincode",None),
			'profile_updated_at'  : datetime.now(),
			'aios_membership_number' : request.values.get('aios_membership_number',None) or None,
			'whatsapp_number': request.form.get("whatsapp_number",None),
			'com_address1'    : request.form.get("c_address1",None),
			'com_address2'    : request.form.get("c_address2",None),
			'com_address3'    : request.form.get("c_address3",None),
			'com_state_id'    : request.values.get("c_state",None),
			'com_country_id'  : request.values.get("c_country",None),
			'com_city'        : request.values.get("c_city",None),
			'com_district'    : request.values.get("c_district",None),
			'com_pincode'     : request.form.get("c_pincode",None),
			'participate_in_next_con' : request.values.get("participate_in_next_con",None),
			'participate_as_faculty_in_next_con' : request.values.get("participate_as_faculty_in_next_con",None),
			'role_of_faculty_you_are_interested' : role_of_faculty_you_are_interested,
			'topics_you_can_deliver' : request.values.get("topics_you_can_deliver",None),
			'Interested_to_evaluate' : request.values.get("Interested_to_evaluate",None),
			'your_core_specialities' : request.values.get("your_core_specialities",None),
			'experience'  : request.values.get("experience",None),
			'type_of_practice'  : request.values.get("type_of_practice",None),
		}

		# data            = additional_data(society_id,data)
		
		state           = UserModel().get_state()
		country         = UserModel().get_country()
		societyData     = Auth.getSociety(society_id)
		
		# attch_type_id = Helper.attch_type_id[society_key]
		attch_type_id   = societyData['attach_type_id']
		user_data       = UserModel().get_member_attachment(user_id,attch_type_id)

		if (int(society_id))== 10:
			specialities_list    = request.form.getlist('chk_specialities')
			specialities_insert_delete(specialities_list,user_id)
		
		file            = request.files['files']
		whats_app_dupli = whats_app_duplicate(data["whatsapp_number"],user_id,society_id)
		if whats_app_dupli == 1:
			flash("Whatsapp number "+ data["whatsapp_number"] +" already exists with us.We cannot use same number","errorMsg")
			user_id     = Cryptography.encrypt(int(user_id))
#           return redirect(url_for('user.getProfile',user_id = user_id,society_id=society_id,society_key=society_key))    
			data        = Helper.join_dicts(user_data, data)
# 			data['dob'] = datetime(int(request.form.get("year",0)),int(request.form.get("month",0)),int(request.form.get("date",0)))
			return render_template('bo/bo_edit.html',data=data,state=state,country = country,Data=societyData,societyData=societyData,society_id=society_id,society_key=society_key)
		else:
#           Log().insert({'level':'INFO','message':str(user_id)})
#           Log().insert({'level':'INFO','message':str(society_id)})
			mobile_count = UserModel().get_mobile_count(data["mobile"],user_id,society_id)
			if mobile_count > 0 :
				flash("Mobile number "+ data["mobile"] +" already exists with us.We cannot use same number","errorMsg")
				data         = Helper.join_dicts(user_data, data)    
				# data['dob']  = datetime(int(request.form.get("year",0)),int(request.form.get("month",0)),int(request.form.get("date",0)))
				return render_template('bo/bo_edit.html',data=data,state=state,country = country,Data=societyData,societyData=societyData,society_id=society_id,society_key=society_key)
			else :

				update_data  = UserModel().update_member(user_id,data)
			flash('Profile has successfully updated',"successMessage")
			# return redirect(url_for('user.mailConfirmation',society_id=society_id,society_key=society_key,user_id = user_id))
			return redirect(url_for('bo.Get_User',user_id =Cryptography.encrypt(int(user_id)),society_id=society_id,society_key=society_key))
			# return render_template('bo/user_view_model.html',data = user_data,society_id=society_id,society_key=society_key,societyData=societyData)
	else:
		flash('Session Expired')
		return redirect(url_for('bo.Get_User',user_id = Cryptography.encrypt(int(user_id)),society_id=society_id,society_key=society_key))
		# return render_template('bo/user_view_model.html',data = user_data,society_id=society_id,society_key=society_key,societyData=societyData)

def specialities_insert_delete(specialities_list,user_id):
	old_specility_data   = UserModel().get_old_specialities(user_id)
	new_specialities  = specialities_list
	insert_specialities = new_specialities
	delete_specialities = []
	if old_specility_data:
		for j in old_specility_data:  
			delete_specialities.append(str(j["category_id"]))
			if str(j["category_id"]) in new_specialities:
				delete_specialities.remove(str(j["category_id"]))
				insert_specialities.remove(str(j["category_id"]))

	if new_specialities:
		insert_specialities = new_specialities
		created_at = datetime.now()
		UserModel().insert_specialities_db(insert_specialities,user_id,created_at)
	if delete_specialities:
		delete_specialities = ",".join(delete_specialities)
		UserModel().delete_specialities_db(delete_specialities,user_id)
	return "success"

@app.route('/bo/profile_pic_upload', methods = ["GET","POST"])                                     
def ProfilePicUpload():
	if request.method == 'POST':
		user_id         = request.values.get('user_id')
		image_data = request.form['image_data']
		file_name       = request.form['file_name']
		society_id      = request.form['society_id']
		society_key     = request.form['society_key'] 
		user            = Auth.user(society_id)
		societyData     = Auth.getSociety(society_id)
		# societyData = UserModel().get_society(society_id,society_key)
		if image_data :
			acl             ="public-read"
			s3              = boto3.client("s3",aws_access_key_id='AKIAILLDAQ7NFUMVOYLQ',aws_secret_access_key='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')
			split_tup       = os.path.splitext(file_name)
			file_name       = split_tup[0]
			file_extension  = split_tup[1]
			file_str        = "Photograph"+file_extension
			if " " in file_str :
				file_str   = file_str.replace(" ","")
			else :
				pass

			try:
				bucket     = Auth.getSociety(society_id).get("aws_bucket")
				if bucket == 'common-application':
					foldername = str(society_key)+"/user_attachment"
				else:
					foldername = "user_attachment" 

				if image_data: 
					image_data = base64.b64decode(image_data.split(',')[1])
					image      = Image.open(io.BytesIO(image_data))
					if image.mode == 'RGBA':
						image = image.convert('RGB')
					image.save(os.path.join('core/static/temp_images', file_str))
					img_path = os.path.join('core/static/temp_images/'+ file_str)
					with open(img_path, 'rb') as f:
						response = s3.upload_fileobj(f,bucket,foldername+'/'+user_id+'/'+ file_str, ExtraArgs={"ACL": acl, "ContentType": "image/jpeg"})        
					os.remove('core/static/temp_images/'+ file_str) 
					file_path  = "https://"+bucket+".s3-ap-southeast-1.amazonaws.com/"+foldername+"/"+str(user_id)
					data_1     = {
								'attach_path'      : file_path,
								'attach_file_name' : file_str,
								'attach_type_id'   : societyData['attach_type_id'],
								 }
					update_data = UserModel().update_attachemant(user_id,data_1,str(datetime.now()))

				return json.dumps(data_1)
					# response   = s3.upload_fileobj(file, bucket,foldername+'/'+str(user_id)+'/'+ file_str, ExtraArgs={"ACL": acl,"ContentType": file.content_type})
			except ClientError as e:
				logging.error(e)
				flash("Image upload failed.","errorMsg")
				user_id     = Cryptography.encrypt(int(user_id))
				return redirect(url_for('user.getProfile',society_id=society_id,society_key=society_key))
		else :
			pass

	return"success" 


def whats_app_duplicate(whatsapp_no,user_id,society_id):
	if whatsapp_no:
		count_whatsapp_num = UserModel().count_whatsapp_num(whatsapp_no,user_id,society_id)
		if count_whatsapp_num > 0:
			return 1
		else:
			return "success"
	else:
		return "success"    

@app.route('/bo/send_remainder/<user_id>/<society_id>/<society_key>',methods=["GET","POST"])
@RouteGroup.society_required
def ViewSendRemainder(user_id,society_id,society_key):
	societyData     = Auth.getSociety(society_id)
	user_id         = int(Cryptography.decrypt(user_id))
	attch_type_id   = societyData['attach_type_id']
	user            = UserModel().get_member_attachment(user_id,attch_type_id)
	template_name   ="profile_remainder_mail"
	mailData        = UserModel().get_mail_template(society_id,template_name)
	full_name       = user['prefix']+user['full_name'] if user['prefix'] else user['full_name']
	subject_data    = {'full_name': full_name}
	subject         = Helper.merge_tags(mailData.subject,subject_data)
	mail_data       = {
			'html_content':mailData.mail_content,
			'data' :user,
			'user' :user,
			'societyData':societyData
	}
	mail_content     = Helper.convert_html_from_string(mail_data)
	return render_template('bo/send_remainder.html',society_id=society_id,society_key=society_key,user=user,societyData=societyData,subject=subject,mail_content=mail_content)

@app.route('/send_remainder_mail/<user_id>/<society_id>/<society_key>', methods = ["GET","POST"])
@RouteGroup.society_required
def SendRemainderMail(user_id,society_id,society_key):
	user_id         = unquote(user_id)
	societyData     = UserModel().get_society(society_id,society_key) 
	user            = UserModel().get_member(user_id)
	template_name   = "profile_remainder_mail"
	mailData        = UserModel().get_mail_template(society_id,template_name)
	full_name       = user['prefix']+user['full_name'] if user['prefix'] else user['full_name']
	subject_data    = {'full_name': full_name}
	subject         = Helper.merge_tags(mailData.subject,subject_data)
 

	if request.method == "POST" :
		email   = request.form['sample_email']
		subject = "SAMPLE : " + subject 
		flash("Successfully sent sample mail","successMsg")
	else:   
		email   = user['email']
		flash("Successfully sent mail to Applicant","successMsg")
	mail_data   = {
			'html_content':mailData.mail_content,
			'data' :user,
			'user' :user,
			'societyData':societyData
	}
	mail_content    = Helper.convert_html_from_string(mail_data)
	html            = render_template('bo/email/bo_mail_template.html',mail_content=mail_content,societyData=societyData,user=user)
	EMAIL.sendMail(subject,html,email,mailData,societyData)
	encrypt_user_id = Cryptography.encrypt(int(user_id))
	return redirect(url_for('bo.ViewSendRemainder',user_id=encrypt_user_id,society_id=society_id,society_key=society_key))

#-Analystics----------------------------------------------------------------------------------------------------------------------------
@app.route('/analytics/<society_id>/<society_key>/<in_profile_filter>', methods = ["GET","POST"])
@app.route('/analytics/<society_id>/<society_key>', methods = ["GET","POST"])
@RouteGroup.society_required
def GetAnalystics(society_id,society_key,in_profile_filter=0):
	if request.method == 'POST':
		in_profile_filter = request.values.get('in_profile_filter') or 0
	else:
		in_profile_filter = in_profile_filter
	societyData     = Auth.getSociety(society_id)
	in_count 		= None
	in_filter 	    = 'dashboard'
	in_from         = None
	in_to           = None
	
	
	analytic_data   = UserModel().usp_profile_analytics_v2(society_id,in_count,in_filter,in_from,in_to,in_profile_filter)
	for index,value in enumerate(analytic_data) :
		if index == 0 :
			monthwise_data   = value 
		if index == 1:
			datewise_data    = value
		if index == 2:
			max_min_year     = value[0]
		if index == 3:
			max_min_date     = value[0]

	end_month = datetime.now()
	end_month = datetime.date(end_month)
	start_month = end_month - dateutil.relativedelta.relativedelta(months=2)
	
	month_list=[]
	while start_month <= end_month:
		month_year_format = start_month.strftime("%B,%Y")
		month_list.append(month_year_format)
		start_month += timedelta(days=32 - start_month.day)
		start_month = start_month.replace(day=1)
	
	monthwise_data = list(reversed(monthwise_data))
	months_label             = []
	months_counts            = []
	months_sum_counts        = []
	count_month ={}
	for m in monthwise_data:
		month  = m['month_name']
		months_label.append(month)
		count_month[month]=m['user_count']
	for ml in month_list:
		if ml in(months_label):
			count = count_month[ml]
			months_counts.append(count)
		else:
			months_counts.append(0)
		months_sum_counts.append(sum(months_counts))
	maxValue  = max(months_sum_counts)
	minValue  = min(months_sum_counts)
	month_length    = len(months_label)
	max_myear = datetime.now().strftime("%Y-%m")
	min_myear = max_min_year['min_year_and_month']

	end_date = datetime.now()
	end_date = datetime.date(end_date)
	start_date = end_date - timedelta(days=6)
	
	date_list = []
	while start_date <= end_date:
		date_list.append(start_date.strftime('%d-%m-%Y'))
		start_date += timedelta(days=1)

	datewise_data = list(reversed(datewise_data))
	dates_label          = []
	dates_counts         = []
	dates_sum_counts     = []
	count_data = {}
	# profile_updated_date = []
	for d in datewise_data:
		date  = d['date_no']
		count_data[date.strftime('%d-%m-%Y')] = d['user_count']
		dates_label.append(date.strftime('%d-%m-%Y'))
	for dl in date_list:
		if dl in (dates_label):
			count = count_data[dl] 
			dates_counts.append(count)
		else:
			dates_counts.append(0)
		dates_sum_counts.append(sum(dates_counts))
	date_maxValue = max(dates_sum_counts)
	date_minValue = min(dates_sum_counts)
	date_length   = len(dates_label)
	maximum_date  = datetime.now().strftime("%Y-%m-%d")
	minimum_date  = max_min_date['minimum_date']

	html_data     = render_template('bo/analytics/analytics_monthwise.html',months_label=months_label,months_sum_counts=months_sum_counts,maxValue=maxValue,minValue=minValue,max_myear=max_myear,min_myear=min_myear,months_counts=months_counts,month_length=month_length,in_count=3,month_list=month_list)
	datewise_data = render_template('bo/analytics/analytics_datewise.html',dates_label=dates_label,dates_sum_counts=dates_sum_counts,date_maxValue=date_maxValue,date_minValue=date_minValue,maximum_date=maximum_date,minimum_date=minimum_date,dates_counts=dates_counts,date_length=date_length,in_count=7,date_list=date_list)
	return render_template('bo/analytics/analytics_index.html',society_id=society_id,society_key=society_key,societyData=societyData,html_data=html_data,datewise_data=datewise_data,in_profile_filter=in_profile_filter,datetime=datetime)

@app.route('/post_in_monthwise/<society_id>/<society_key>' , methods = ["POST"])
@RouteGroup.society_required
def PostInMonth(society_id,society_key):
	try:
		societyData     = Auth.getSociety(society_id)
		in_count        = request.values.get('in_count') or None
		in_filter  		= 'monthwise'
		in_from         = request.values.get('from_month') or None
		in_to		    = request.values.get('to_month')
		in_profile_filter  = request.values.get('in_profile_filter')
		
		if in_count:
			end_month = datetime.now()
			end_month = datetime.date(end_month)
			start_month = end_month - dateutil.relativedelta.relativedelta(months=int(in_count)-1)
			in_from = datetime.strftime(start_month, "%Y-%m")
			in_to = datetime.strftime(end_month, "%Y-%m")

		else:
			start_month = datetime.strptime(in_from, "%Y-%m")
			end_month = datetime.strptime(in_to, "%Y-%m")

		month_list=[]
		while start_month <= end_month:
			month_year_format = start_month.strftime("%B,%Y")
			month_list.append(month_year_format)
			start_month += timedelta(days=32 - start_month.day)
			start_month = start_month.replace(day=1)

		analytic_data   = UserModel().usp_profile_analytics_v2(society_id,None,in_filter,in_from,in_to,in_profile_filter)
		for index,value in enumerate(analytic_data) :
			if index == 0 :
				monthwise_data = value
			if index == 2 :
				max_min_year   = value[0]

		if month_list:
			monthwise_data      = list(reversed(monthwise_data))
			months_label 		= []
			months_counts 		= []
			months_sum_counts   = []
			count_month ={}
			for m in monthwise_data:
				month  = m['month_name']
				months_label.append(month)
				count_month[month]=m['user_count']
			for ml in month_list:
				if ml in(months_label):
					count = count_month[ml]
					months_counts.append(count)
				else:
					months_counts.append(0)
				months_sum_counts.append(sum(months_counts))
			maxValue  = max(months_sum_counts)
			minValue  = min(months_sum_counts)
			month_length    = len(months_label)
			max_myear = datetime.now().strftime("%Y-%m")
			min_myear = max_min_year['min_year_and_month']
			html_data = render_template('bo/analytics/analytics_monthwise.html',months_label=months_label,months_sum_counts=months_sum_counts,maxValue=maxValue,minValue=minValue,max_myear=max_myear,min_myear=min_myear,months_counts=months_counts,from_month=in_from,to_month=in_to,in_count=in_count,month_length=month_length,month_list=month_list)
			data      = {"html_data" :html_data,"msg" : "success" ,"status" : 1 }
			json_data = json.dumps(data,default = str)
			return json_data
	except Exception as e:
		data      = {"html_data" :"","msg" : str(e), "status" : 401 }
		json_data = json.dumps(data,default = str)
		return json_data
	
@app.route('/post_in_datewise/<society_id>/<society_key>' , methods = ["POST"])
@RouteGroup.society_required
def PostInDatewise(society_id,society_key):
	try:
		societyData     = Auth.getSociety(society_id)
		in_count        = request.values.get('in_count') or None
		in_filter		= 'daywise'
		in_from       	= request.values.get('from_date') or None
		in_to  		    = request.values.get('todate') or None
		in_profile_filter = request.values.get('in_profile_filter')

		if in_count:
			end_date = datetime.now()
			end_date = datetime.date(end_date)
			start_date = end_date - timedelta(days=int(in_count)-1)
			in_from = datetime.strftime(start_date, "%Y-%m-%d")
			in_to = datetime.strftime(end_date, "%Y-%m-%d")

		else:
			end_date=datetime.strptime(in_to, "%Y-%m-%d")
			start_date = datetime.strptime(in_from, "%Y-%m-%d")

		date_list = []
		while start_date <= end_date:
			date_list.append(start_date.strftime('%d-%m-%Y'))
			start_date += timedelta(days=1)

		analytic_data   = UserModel().usp_profile_analytics_v2(society_id,None,in_filter,in_from,in_to,in_profile_filter)
		for index,value in enumerate(analytic_data) :
			if index == 0 :
				datewise_data   = value
			if index == 3 :
				max_min_date    = value[0]

		if date_list:
			datewise_data     = list(reversed(datewise_data))
			dates_label       = []
			dates_counts      = []
			dates_sum_counts  = []
			count_data = {}
			for d in datewise_data:
				# count = d['user_count']
				date  = d['date_no']
				count_data[date.strftime('%d-%m-%Y')] = d['user_count']
				dates_label.append(date.strftime('%d-%m-%Y'))
			for dl in date_list:
				if dl in (dates_label):
					count = count_data[dl] 
					dates_counts.append(count)
				else:
					dates_counts.append(0)
				dates_sum_counts.append(sum(dates_counts))
			date_maxValue = max(dates_sum_counts)
			date_minValue = min(dates_sum_counts)
			date_length = len(dates_label)
			maximum_date  = datetime.now().strftime("%Y-%m-%d")
			minimum_date  = max_min_date['minimum_date']
			datewise_data = render_template('bo/analytics/analytics_datewise.html',dates_label=dates_label,dates_sum_counts=dates_sum_counts,date_maxValue=date_maxValue,date_minValue=date_minValue,maximum_date=maximum_date,minimum_date=minimum_date,dates_counts=dates_counts,from_date=in_from,todate=in_to,in_count=in_count,date_length=date_length,date_list=date_list)
			data      = {"datewise_data" :datewise_data,"msg" : "success" ,"status" : 1 }
			json_data = json.dumps(data,default = str)
			return json_data
	except Exception as e:
		data      = {"datewise_data" :"","msg" : str(e), "status" : 401 }
		json_data = json.dumps(data,default = str)
		return json_data
	
# @app.route('/post_analytics/<society_id>/<society_key>', methods = ["GET","POST"])
# # @app.route('/analytics/<society_id>/<society_key>', methods = ["GET","POST"])
# @RouteGroup.society_required
# def PostAnalytics(society_id,society_key):
# 	try:
# 		societyData     = Auth.getSociety(society_id)
# 		in_count 		= None
# 		in_filter 	    = 'dashboard'
# 		in_from         = None
# 		in_to           = None
# 		in_profile_filter = request.values.get('in_profile_filter') or 0
# 		analytic_data   = UserModel().usp_profile_analytics_v2(society_id,in_count,in_filter,in_from,in_to,in_profile_filter)
# 		for index,value in enumerate(analytic_data) :
# 			if index == 0 :
# 				monthwise_data   = value 
# 			if index == 1:
# 				datewise_data    = value
# 			if index == 2:
# 				max_min_year     = value[0]
# 			if index == 3:
# 				max_min_date     = value[0]

# 		end_month = datetime.now()
# 		end_month = datetime.date(end_month)
# 		start_month = end_month - dateutil.relativedelta.relativedelta(months=2)
		
# 		month_list=[]
# 		while start_month <= end_month:
# 			month_year_format = start_month.strftime("%B,%Y")
# 			month_list.append(month_year_format)
# 			start_month += timedelta(days=32 - start_month.day)
# 			start_month = start_month.replace(day=1)

# 		monthwise_data = list(reversed(monthwise_data))
# 		months_label             = []
# 		months_counts            = []
# 		months_sum_counts        = []
# 		count_month ={}
# 		for m in monthwise_data:
# 			month  = m['month_name']
# 			months_label.append(month)
# 			count_month[month]=m['user_count']
# 		for ml in month_list:
# 			if ml in(months_label):
# 				count = count_month[ml]
# 				months_counts.append(count)
# 			else:
# 				months_counts.append(0)
# 			months_sum_counts.append(sum(months_counts))
# 		maxValue  = max(months_sum_counts)
# 		minValue  = min(months_sum_counts)
# 		month_length    = len(months_label)
# 		max_myear = datetime.now().strftime("%Y-%m")
# 		min_myear = max_min_year['min_year_and_month']

# 		end_date = datetime.now()
# 		end_date = datetime.date(end_date)
# 		start_date = end_date - timedelta(days=6)
# 		date_list = []
# 		while start_date <= end_date:
# 			date_list.append(start_date.strftime('%d-%m-%Y'))
# 			start_date += timedelta(days=1)

# 		datewise_data = list(reversed(datewise_data))
# 		dates_label          = []
# 		dates_counts         = []
# 		dates_sum_counts     = []
# 		count_data = {}
# 		# profile_updated_date = []
# 		for d in datewise_data:
# 			date  = d['date_no']
# 			count_data[date.strftime('%d-%m-%Y')] = d['user_count']
# 			dates_label.append(date.strftime('%d-%m-%Y'))
# 		for dl in date_list:
# 			if dl in (dates_label):
# 				count = count_data[dl] 
# 				dates_counts.append(count)
# 			else:
# 				dates_counts.append(0)
# 			dates_sum_counts.append(sum(dates_counts))
# 		date_maxValue = max(dates_sum_counts)
# 		date_minValue = min(dates_sum_counts)
# 		date_length   = len(dates_label)
# 		maximum_date  = datetime.now().strftime("%Y-%m-%d")
# 		minimum_date  = max_min_date['minimum_date']

# 		html_data     = render_template('bo/analytics/analytics_monthwise.html',months_label=months_label,months_sum_counts=months_sum_counts,maxValue=maxValue,minValue=minValue,max_myear=max_myear,min_myear=min_myear,months_counts=months_counts,month_length=month_length,in_count=3,month_list=month_list)
# 		datewise_data = render_template('bo/analytics/analytics_datewise.html',dates_label=dates_label,dates_sum_counts=dates_sum_counts,date_maxValue=date_maxValue,date_minValue=date_minValue,maximum_date=maximum_date,minimum_date=minimum_date,dates_counts=dates_counts,date_length=date_length,in_count=7,date_list=date_list)
# 		data      = {"html_data":html_data,"datewise_data" :datewise_data,"in_profile_filter" : in_profile_filter,"msg" : "success" ,"status" : 1 }
# 		json_data = json.dumps(data,default = str)
# 		return json_data
# 		# return render_template('bo/analytics/analytics_index.html',society_id=society_id,society_key=society_key,societyData=societyData,html_data=html_data,datewise_data=datewise_data)
# 	except Exception as e:
# 		data      = {"html_data":"","datewise_data" :"","msg" : str(e), "status" : 401 }
# 		json_data = json.dumps(data,default = str)
# 		return json_data
